###############################################################################
###############################################################################
##
##  Copyright (C) 2004-2008 Red Hat, Inc.  All rights reserved.
##
##  This copyrighted material is made available to anyone wishing to use,
##  modify, copy, or redistribute it subject to the terms and conditions
##  of the GNU General Public License v.2.
##
###############################################################################
###############################################################################

Name: cmirror
Version: 1.1.39
Release: 10%{?dist}
License: GPL
Group: System Environment/Base
Summary: cmirror - The Cluster Mirror Package
Requires(post): /sbin/chkconfig
Requires(preun): /sbin/chkconfig
BuildRequires: openais openais-devel e2fsprogs-devel
#BuildRequires: kernel-devel
Requires: openais
ExclusiveArch: i386 x86_64 ia64 ppc
Source0: cmirror-%{version}.tar.gz
Source1: COPYING
Patch0: cmirror-dminclude.patch
Patch1: bz520915.patch
Patch2: bz518665.patch
Patch3: bz488102.patch
Patch4: bz488102-part2.patch
Patch5: bz544253.patch
Patch6: bz456575.patch
Patch7: io-hang-bug-fix.patch
Patch8: cmirror-fix-includes.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
cmirror - Cluster Mirroring

%prep
%setup -q
%patch0 -p1 -b .fixbuild
%patch1 -p2 -b .bz520915
%patch2 -p2 -b .bz518665
%patch3 -p2 -b .bz488102
%patch4 -p2 -b .bz488102-part2
%patch5 -p2 -b .bz544253
%patch6 -p2 -b .bz456575
%patch7 -p2 -b .hang
%patch8 -p2 -b .it1342943

%build
./configure --libdir=%{_libdir} --sbindir=%{_sbindir}
make

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add cmirror

%preun
if [ "$1" = 0 ]; then
	/sbin/chkconfig --del cmirror
fi

%files
%defattr(-,root,root)
%config /etc/init.d/cmirror
/%{_sbindir}/clogd


%changelog
* Wed Sep 8 2010 Jonathan Brassow <jbrassow@redhat.com>
- Fix a wrong include file in src/functions.c
- Resolves: rhbz#631925

* Mon Aug 30 2010 Jonathan Brassow <jbrassow@redhat.com>
- Fix possible corruption issue on mirrors with more than 2 images
- Fix I/O hang after cluster mirror creation with '--nosync' flag
- Resolves: rhbz#456575 rhbz#471291

* Wed Mar 3 2010 Jonathan Brassow <jbrassow@redhat.com>
- Prevent previous mirror creation failures from causing kernel panics
- Resolves: rhbz#544253

* Mon Feb 22 2010 Jonathan Brassow <jbrassow@redhat.com>
- Communication data was not completely insulated architecturally
- Resolves: rhbz#488102

* Tue Dec 22 2009 Chris Feist <cfeist@redhat.com>
- Init script no longer throws errors on 'stop'.
- Cmirror no longer generates errors if openais stops.
- Mixed architecture and rolling upgrade issues have been fixed.
- Resolves: rhbz#488102 rhbz#518665 rhbz#520915

* Mon Jul 27 2009 Chris Feist <cfeist@redhat.com>
- Local UIDs are now used to prevent more than one log created with the
  same UUID.
- Resolves: rhbz#506843

* Tue Jul 14 2009 Chris Feist <cfeist@redhat.com>
- Fixed more issues which caused the copy percentage of a corelog mirror to
  get stuck.
- Resolves: rhbz#474174 rhbz#491340

* Tue May 05 2009 Chris Feist <cfeist@redhat.com>
- Copy percentage of corelog mirror no longer gets stuck in certain cases.
- A segfault in clogd was fixed which was caused by mirrors being suspended
  quickly after being started.
- During a sync attempt the copy percentage will no longer hang due to the
  receipt of stale checkpoint data.
- Resolves: rhbz#474174 rhbz#484968 rhbz#491340

* Tue Dec 09 2008 Chris Feist <cfeist@redhat.com>
- Fixes for checkpoint issues.
- Resolves: rhbz#467908

* Wed Dec 03 2008 Chris Feist <cfeist@redhat.com>
- Fixed clogd segfault on clusters with more than 10 nodes.
- Resolves: rhbz#471448

* Mon Nov 06 2008 Chris Feist <cfeist@redhat.com>
- More list corrpution fixes
- Fixed bug which can cause the sync percentage to go over 100.
- Resolves: rhbz#464550

* Mon Oct 27 2008 Chris Feist <cfeist@redhat.com>
- Fixed potential hangs in cmirror due to list corruption.

* Mon Oct 20 2008 Chris Feist <cfeist@redhat.com>
- Fixed a checkpoint ordering issue, where a checkpoint could be populated
  with data from the wrong moment in time.
- Fixed problem where resending requests when a server leaves would include
  requests that should have been recieved after the server had gone (so no
  resend should have been necessary).
- Resolves: rhbz#464550

* Tue Oct 14 2008 Chris Feist <cfeist@redhat.com>
- Allow time for exiting server responses to settle out before resending
  requests
- Various debugging enhancements
- Resolves: rhbz#464550 rhbz#464934

* Wed Oct 08 2008 Chris Feist <cfeist@redhat.com>
- cmirror init script no longer fails to start if it's already started.

* Fri Sep 05 2008 Chris Feist <cfeist@redhat.com>
- cmirror init script now provides a status output
- Resolves: rhbz#460229

* Tue Jul 15 2008 Chris Feist <cfeist@redhat.com>
- Fixes issues when using small (<= 30M) mirrors)

* Wed Jul 02 2008 Chris Feist <cfeist@redhat.com>
- Fixed issue with disk->core log not remembering sync status
- Resolves: rhbz#429608

* Mon Nov 12 2007 Chris Feist <cfeist@redhat.com>
- First build
